<?php

//
// eolephpCAS simple client
//

// import eolephpCAS lib
include_once('CAS/eoleCAS.php');

eolephpCAS::setDebug('/tmp/testcas.log');

// initialize eolephpCAS
eolephpCAS::client(CAS_VERSION_2_0,'195.221.237.13',8443,'');

// no SSL validation for the CAS server
// eolephpCAS::setNoCasServerValidation();

// force CAS authentication
eolephpCAS::forceAuthentication();

// at this step, the user has been authenticated by the CAS server
// and the user's login name can be read with eolephpCAS::getUser().

// logout if desired
if (isset($_REQUEST['logout'])) {
	eolephpCAS::logout('http://195.221.237.13/exemplecas');
}

// for this test, simply print that the authentication was successfull
?>
<?php
/**
 * * Takes xml as a string and returns it nicely indented
 * *
 * * @param string $xml The xml to beautify
 * * @param boolean $html_output If the xml should be formatted for display on an html page
 * * @return string The beautified xml
 * */
function xml_pretty_printer($xml, $html_output=FALSE)
{
	$xml_obj = new SimpleXMLElement($xml);
	$xml_lines = explode("\n", $xml_obj->asXML());
	$indent_level = 0;
	
	$new_xml_lines = array();
	foreach ($xml_lines as $xml_line) {
		if (preg_match('#^(<[a-z0-9_:-]+((\s+[a-z0-9_:-]+="[^"]+")*)?>.*<\s*/\s*[^>]+>)|(<[a-z0-9_:-]+((\s+[a-z0-9_:-]+="[^"]+")*)?\s*/\s*>)#i', ltrim($xml_line))) {
			$new_line = str_pad('', $indent_level*4) . ltrim($xml_line);
			$new_xml_lines[] = $new_line;
		} elseif (preg_match('#^<[a-z0-9_:-]+((\s+[a-z0-9_:-]+="[^"]+")*)?>#i', ltrim($xml_line))) {
			$new_line = str_pad('', $indent_level*4) . ltrim($xml_line);
			$indent_level++;
			$new_xml_lines[] = $new_line;
		} elseif (preg_match('#<\s*/\s*[^>/]+>#i', $xml_line)) {
			$indent_level--;
			if (trim($new_xml_lines[sizeof($new_xml_lines)-1]) == trim(str_replace("/", "", $xml_line))) {
				$new_xml_lines[sizeof($new_xml_lines)-1] .= $xml_line;
			} else {
				$new_line = str_pad('', $indent_level*4) . $xml_line;
				$new_xml_lines[] = $new_line;
			}
		} else {
			$new_line = str_pad('', $indent_level*4) . $xml_line;
			$new_xml_lines[] = $new_line;
		}
	}
	
	$xml = join("\n", $new_xml_lines);
	return ($html_output) ? '<pre>' . htmlentities($xml) . '</pre>' : $xml;
}
?>
<html>
  <head>
    <title>eolephpCAS simple client</title>
	<style>
	body{font-size:12px; margin:5px;}
	.titre{font-size:15px;font-weight:bold;	}
	.titre1{font-size:19px;font-weight:bold;padding-top:20px;margin:3px;text-decoration:underline;}
	.titre2{font-size:17px;padding-top:10px;margin:3px;font-weight:bold;text-decoration:underline;padding-left:5px;}
	.titre3{font-size:15px;padding-top:10px;margin:3px;padding-left:10px;}
	.section1{border:1px dotted #555595;background-color:#fffebe; color:#222292;padding:3px; margin:5px;margin-left:15px;}
	</style>
  </head>
  <body>
    <p>Version de eole phpCAS <b><?php echo eolephpCAS::getVersion(); ?></b>.</p>
    <div class="titre">Authentification Réussie</div>
    <p>Le login utilisateur <b><?php echo eolephpCAS::getUser(); ?></b>.</p>
    <p><a href="?logout=">Déconnexion</a></p>
	<hr />
	<div class="titre1"> Présentation des fonctionnalités du Serveur SSO Eole</div>
	
	Le serveur sso permet une authentification centralisée des utilisateurs, notamment selon le protocole CAS.<br />
	Il est possible de fournir des filtres aux applications afin de fournir des données utilisateurs aux applications.<br />
	Voyons comment l'utiliser dans le cadre du php.<br />

	<div class="titre2">AUTHENTIFICATION</div>
	Dans votre script php, importer le client eolephpcas :
	<div class="section1">
	include_once('CAS/eoleCAS.php');</div><br />
	1 - Renseignez le serveur eole-SSO utilisé :
	<div class="section1">eolephpCAS::client(CAS_VERSION_2_0,"l'adresse du serveur sso","le port utilisé",'');</div><br />
	2 - On authentifie :
	<div class="section1">eolephpCAS::checkAuthentication();</div>
	A ce moment là, l'authentification est mise en place, sans que votre application n'est à gérer les mots de passe des utilisteurs.<br /><br />
	3 - On récupère le nom de l'utilisateur :
	<div class="section1">eolephpCAS::getUser();</div>
	4 - On déconnecte :
	<div class="section1">eolephpCAS::logout("adresse de l'application en mode déconnecté")</div><br /><br />

	<div class="titre2">LES DONNÉES UTILISATEURS</div>
	Le serveur SSO est capable de fournir des données utilisateurs aux applications sous la forme de xml.<br />
	Un filtre par défaut se contente de fournir l'uid de l'utilisateur qui se connecte, mais tout un ensemble de données peut être fournit.<br />
	<div class="titre2">Première étape : configurer l'application dans un fichier monfiltre_apps.ini</div>
	On renseigne une url et un filtre associé. Quand l'url 'http://adresse/lechemin' me demande d'authentifier quelqu'un, une fois authentifiée, 
	je lui renvoie les données renseignées dans le filtre 'monfiltre'.
	<div class='section1'>
	<pre>
		[democas]
		baseurl=/lechemin
		scheme=http
		addr=0/0
		typeaddr=ip
		filter=<b>monfiltre</b></pre>
	</div>
	<div class="titre2">Deuxième étape : configurer le filtre <b>monfiltre</b>.ini</div>
	<div class='section1'><pre>
		[user]
		user=uid                
           
		[infos] 
		user_groups=user_groups
		typeadmin=typeadmin
	</pre></div>
	<div class="titre2">Troisième étape : récupérer les données dans le script PHP </div>
	<div class="titre3">Sous forme de XML</div>
	Dans le script php :
	<div class="section1">eolephpCAS::getCasXML()	</div>
	Ici, les données récupérées pour l'utilisateur courant sont :
	<div class="section1">
		<? echo xml_pretty_printer(eolephpCAS::getCasXML(), TRUE); ?>
	</div>
	<div class="titre3">Sous forme de tableau php</div>
	Dans le script php :
	<div class="section1">eolephpCAS::getDetails() </div>
	Ici les données renvoyées pour l'utilisateur courant sont :	
	<div class="section1">
		<? print_r (eolephpCAS::getDetails() ); ?>
	</div>
<br /><br />
</body>
</html>
